/*
 *  2016 Maciej Wiecierzewski
 */

var mysql = require("mysql");
var async = require("async");

var database = {
    host: "localhost",
    user: "root",
    password: "",
    database: "browser_ext",
    
    connect: function(callback)
    {
        this.connection = mysql.createConnection({
            host: this.host,
            user: this.user,
            password: this.password,
            database: this.database
          });

        this.connection.connect(connCalback);

        function connCalback(err)
        {
            if(err)
            {
                console.error('error connecting: ' + err.stack);
                return;
            }
            else
                console.log("Connected");
                //console.log('connected as id ' + this.connection.threadId);
            
            callback();
        }
    },
    
    endConnection: function(callback)
    {
        this.connection.end();
        callback();
    },
    
    createTables: function(callback)
    {
        var query = "CREATE TABLE `words_list` " +
            "(id INT NOT NULL AUTO_INCREMENT, PRIMARY KEY (`id`)," +
            "word TINYTEXT NOT NULL, " +
            "timestamp DATETIME(3) NOT NULL DEFAULT CURRENT_TIMESTAMP)" +
            "ENGINE = InnoDB;";
    
        this.connection.query(query, queryCallback);
        
        function queryCallback(error, results, fields)
        {
            if(error)
                console.error('error: ' + error.code);
            else
                console.log("Tables created");
            
            callback(error, results, fields);
        }
    },
    
    select: function(data, callback)
    {
        var query = "SELECT ";
        
        var coma = "";
        if(data.get.indexOf("id") !== -1)
        {
            query += "id";
            coma = ", ";
        }
        if(data.get.indexOf("word") !== -1)
        {
            query += coma + "word";
            coma = ", ";
        }
        if(data.get.indexOf("timestamp") !== -1)
        {
            query += coma + "timestamp";
        }
        
        query += " FROM words_list";
        
        if(typeof data.where === "string")
        {
            query += " WHERE ";
            coma = "";
            if(typeof data.where.id === "string")
            {
                query += "id = '" + mysql.escape(data.where.id) + "'";
                coma = ", ";
            }
            if(typeof data.where.word === "string")
            {
                query += coma + "word = '" + mysql.escape(data.where.word) + "'";
                coma = ", ";
            }
            if(typeof data.where.timestamp === "string")
            {
                query += coma + "timestamp = '" + mysql.escape(data.where.timestamp); + "'";
            }
        }
        query += ";";
        
        console.log(query);
        this.connection.query(query, queryCallback);
        
        function queryCallback(error, results, fields)
        {
            if(error)
            {
                console.error('error: ' + error.code);
                callback("error");
                
                return;
            }
            
            callback(null, results, fields);
        }
    },
    
    insert: function(word, unixtime, callback)
    {
        var sqlStr = "INSERT INTO words_list (word, timestamp) VALUES ( ? , FROM_UNIXTIME( ? ) )";
        var query = mysql.format(sqlStr, [word, unixtime*0.001]);
        
        console.log(query);
        this.connection.query(query, queryCallback);
        
        function queryCallback(error, results, fields)
        {
            if(error)
            {
                console.error('error: ' + error.code);
                return;
            }
            
            callback(error, results, fields);
        }
    },
    
    delete: function(word, callback)
    {
        var sqlStr = "DELETE FROM words_list WHERE word = ?";
        var query = mysql.format(sqlStr, [word]);
        
        console.log(query);
        this.connection.query(query, queryCallback);
        
        function queryCallback(error, results, fields)
        {
            if(error)
            {
                console.error('error: ' + error.code);
                return;
            }
            
            callback(error, results, fields);
        }
    }
}

module.exports.database = database;
