/*
 *  2016 Maciej Wiecierzewski
 */

var async = require("async");

var database = require("./database");
database = database.database;

var server = require("./server");
server = server.server;

function databaseReady(callback)
{
    server.databaseReady = true;
    callback();
}

function seriesCallback(error, result)
{
    console.log(error);
    console.log(result);
}

async.series([function(callback){ database.connect(function() { callback(null, 'database.connect'); } ); },
            function(callback){ database.createTables(function() { callback(null, 'database.createTables'); } ); },
            function(callback){ server.init(function() { callback(null, 'server.init'); } ); },
            function(callback){ databaseReady(function() { callback(null, 'databaseReady'); } ); }],
            seriesCallback);
